package info.joaorebelo.JRFramework;

import info.joaorebelo.JRjavaUtils.table.JRtable;
import info.joaorebelo.JRjavaUtils.ui.JRtabCloseButton;
import info.joaorebelo.JRjavaUtils.ui.leftMenu;
import java.awt.BorderLayout;
import java.awt.Toolkit;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;
import table.ui.actor.ActorTable;

/**
 *
 * @author joao
 */
public class mainLayout extends javax.swing.JFrame {

    /**
     * i18n resource
     */
    private i18n i18n;
    /**
     * Base panel where the components are
     */
    private JPanel basePanel;

    /**
     * Get the base panel component
     *
     * @return
     */
    public JPanel getBasePanel() {
        return this.basePanel;
    }

    /**
     * TabedPane fro tabs
     */
    private JTabbedPane tp;
    
    /**
     * Split pane for tabs an menu
     */
    private JSplitPane sp;
    
    /**
     * South panel
     */
    protected southPanel south;
    
    /**
     * Verify if a tab exist
     *
     * @param tabName
     * @return
     */
    public int tabExist(String tabName) {
        for (int nTab = 0; nTab < this.tp.getTabCount(); nTab++) {
            if (tabName.equals(this.tp.getTitleAt(nTab))) {
                return nTab;
            }
        }
        return -1;
    }

    /**
     * Creates new form mainLayout
     */
    public mainLayout(i18n i18n) {
        
        ImageIcon img = new ImageIcon(getClass().getResource("/resources/Extras_16_16/JR.png"));
        this.setIconImage(img.getImage());
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        if (i18n != null) {
            this.i18n = i18n;
        }
        Toolkit toolkit = Toolkit.getDefaultToolkit();
        this.setSize(toolkit.getScreenSize());
        initComp();
    }

    private void initComp() {
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.basePanel = new JPanel(new BorderLayout(0, 0));

        // add the main manu
        mainMenu mm = new mainMenu(this, this.i18n);
        this.basePanel.add(mm, BorderLayout.NORTH);

        // add the bottom panel
        this.south = new southPanel(this.i18n);
        this.basePanel.add(south, BorderLayout.SOUTH);
        
        // add the tabedPanel
        this.tp = new JTabbedPane();
        
        //Create the splitpane
        this.sp = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, new leftMenu() , tp);
        this.sp.setOneTouchExpandable(true);
        this.sp.setDividerLocation(150);
        this.basePanel.add(sp, BorderLayout.CENTER);
                
        // add the base panel to the frame        
        this.add(this.basePanel);
        south.mekeLabelsSizes();
        
        // set event listener for capslock state
        this.setFocusable(true);
        
        //set visible
        this.setVisible(true);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel4 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        actoresMenuItem = new javax.swing.JMenuItem();
        jMenuFileExit = new javax.swing.JMenuItem();
        jMenu2 = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel1.setPreferredSize(new java.awt.Dimension(90, 25));
        jPanel2.add(jLabel1);

        jPanel1.add(jPanel2, java.awt.BorderLayout.LINE_END);
        jPanel1.add(jPanel3, java.awt.BorderLayout.LINE_START);
        jPanel1.add(jPanel5, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.PAGE_END);
        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jMenu1.setText("File");

        actoresMenuItem.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/Extras_16_16/User.png"))); // NOI18N
        actoresMenuItem.setText("Actores");
        actoresMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                actoresMenuItemActionPerformed(evt);
            }
        });
        jMenu1.add(actoresMenuItem);

        jMenuFileExit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/Extras_16_16/Shutdown.png"))); // NOI18N
        jMenuFileExit.setText("Exit");
        jMenuFileExit.setToolTipText("Exit from application");
        jMenuFileExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jMenuFileExitActionPerformed(evt);
            }
        });
        jMenu1.add(jMenuFileExit);

        jMenuBar1.add(jMenu1);

        jMenu2.setText("Edit");
        jMenuBar1.add(jMenu2);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jMenuFileExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jMenuFileExitActionPerformed
        // TODO add your handling code here:
        System.exit(0);
    }//GEN-LAST:event_jMenuFileExitActionPerformed

    public void getTableActor() {
        String tabName = "Actores";
        Integer tabIndex = tabExist(tabName);
        if (tabIndex > -1) {
            this.tp.setSelectedIndex(tabIndex);
        } else {
            ImageIcon icon = new ImageIcon(getClass().getResource("/resources/Extras_16_16/User.png"));
            JPanel p = new JPanel(new BorderLayout());
            ActorTable a = new ActorTable(this.i18n,p);
            p.add(a, BorderLayout.CENTER);
            this.tp.addTab("Actores", icon, p);
            new JRtabCloseButton(this.tp, this.tp.getTabCount() - 1);
            
        }
    }

    private void actoresMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actoresMenuItemActionPerformed
        // TODO add your handling code here:

        String tabName = "Actores";
        Integer tabIndex = tabExist(tabName);
        if (tabIndex > -1) {
            jTabbedPane1.setSelectedIndex(tabIndex);
        } else {
            ImageIcon icon = new ImageIcon(getClass().getResource("/resources/Extras_16_16/User.png"));
            JPanel p = new JPanel(new BorderLayout());
            p.add(new ActorTable(this.i18n, p), BorderLayout.CENTER);
            jTabbedPane1.addTab("Actores", icon, p);
            new JRtabCloseButton(jTabbedPane1, jTabbedPane1.getTabCount() - 1);

        }

    }//GEN-LAST:event_actoresMenuItemActionPerformed
    /**
     * @param args the command line arguments
     */
//    public static void main(String args[]) {
//        /* Set the Nimbus look and feel */
//        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
//        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
//         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
//         */
//        try {
//            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
//                if ("Nimbus".equals(info.getName())) {
//                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                    break;
//                }
//            }
//        } catch (ClassNotFoundException ex) {
//            java.util.logging.Logger.getLogger(mainLayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (InstantiationException ex) {
//            java.util.logging.Logger.getLogger(mainLayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (IllegalAccessException ex) {
//            java.util.logging.Logger.getLogger(mainLayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
//            java.util.logging.Logger.getLogger(mainLayout.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
//        }
//        //</editor-fold>
//
//        /* Create and display the form */
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new mainLayout().setVisible(true);
//            }
//        });
//    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem actoresMenuItem;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenu jMenu2;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuFileExit;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JTabbedPane jTabbedPane1;
    // End of variables declaration//GEN-END:variables


}
