/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package table.ui.actor;

import info.joaorebelo.JRFramework.i18n;
import info.joaorebelo.JRjavaUtils.ui.JRString;
import sakila.entity.Actor;

/**
 *
 * @author joao
 */
public class ActorForm extends javax.swing.JInternalFrame {

    /**
     * JRtableDataBind
     */
    protected ActorTable actorTable;
    
    
    /**
     * i18n
     */
    i18n i18n;
    
    /**
     * Data class
     */
    Actor actor;
    
    /**
     * Type of form ADD or UPDATE
     */
    protected String typeForm;
    
    /**
     * Create a new Actor Form for add or update actor
     * @param tableDataBind
     * @param i18n
     * @param typeForm  ADD or UPDATE
     */
    public ActorForm(ActorTable actorTable, i18n i18n, String typeForm, Actor actor) {
        initComponents();
        this.actor = actor;
        this.i18n = i18n;
        this.typeForm = typeForm;
        this.actorTable = actorTable;
        initForm();
    }

    private void initForm(){
        try{
        this.jButtonCancel.setName(ActorTable.FORM_CLOSE_BUTTON);
        this.jButtonCancel.setText(JRString.ucfirst(this.i18n.getString("cancel")));
        this.jButtonCancel.addActionListener(this.actorTable);
        this.jButtonSubmit.setName(ActorTable.FORM_SUBMIT_BUTTON);
        this.jButtonSubmit.setText(JRString.ucfirst(this.i18n.getString("submit")));
        this.jButtonSubmit.addActionListener(this.actorTable);
        if(this.typeForm.toLowerCase().equals("update")){
            this.jTextFieldFirstName.setText(actor.getFirstName());
            this.jTextFieldLastName.setText(actor.getLastName());
        }
        }catch(Exception e){
            System.out.println(e.getMessage());
        }
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabelFirstName = new javax.swing.JLabel();
        jTextFieldFirstName = new javax.swing.JTextField();
        jLabelLastName = new javax.swing.JLabel();
        jTextFieldLastName = new javax.swing.JTextField();
        jButtonCancel = new javax.swing.JButton();
        jButtonSubmit = new javax.swing.JButton();

        jLabelFirstName.setText("first_name");

        jLabelLastName.setText("last_name");

        jTextFieldLastName.setName(""); // NOI18N

        jButtonCancel.setText("Cancel");

        jButtonSubmit.setText("Submit");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelFirstName)
                    .addComponent(jTextFieldFirstName, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabelLastName)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addComponent(jButtonCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(18, 18, 18)
                            .addComponent(jButtonSubmit, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addComponent(jTextFieldLastName, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 197, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabelLastName)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldLastName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabelFirstName)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldFirstName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonCancel)
                    .addComponent(jButtonSubmit))
                .addContainerGap(18, Short.MAX_VALUE))
        );

        jLabelFirstName.getAccessibleContext().setAccessibleName("");

        pack();
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancel;
    public javax.swing.JButton jButtonSubmit;
    public javax.swing.JLabel jLabelFirstName;
    public javax.swing.JLabel jLabelLastName;
    public javax.swing.JTextField jTextFieldFirstName;
    public javax.swing.JTextField jTextFieldLastName;
    // End of variables declaration//GEN-END:variables
}
